



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ReactiveX 学习笔记（16）RxPY</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ReactiveX 学习笔记（16）RxPY</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-15 13:27:15 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h3>RxPY</h3>
<p>RxPY 是 ReactiveX 的 Python语言实现。</p>
<pre class="prettyprint linenums"><code># 安装 RxPY<br />
$ pip3 install rx<br />
Successfully installed rx-1.6.1<br />
</code></pre>
<h3>Basics</h3>
<pre class="prettyprint linenums"><code>from rx import Observable<br />
source = Observable.of(&quot;Alpha&quot;, &quot;Beta&quot;, &quot;Gamma&quot;, &quot;Delta&quot;, &quot;Epsilon&quot;)<br />
source.subscribe(on_next=lambda value: print(&quot;Received {0}&quot;.format(value)),<br />
                 on_completed=lambda: print(&quot;Done!&quot;),<br />
                 on_error=lambda error: print(&quot;Error Occurred: {0}&quot;.format(error))<br />
                 )<br />
'''<br />
Received Alpha<br />
Received Beta<br />
Received Gamma<br />
Received Delta<br />
Received Epsilon<br />
Done!<br />
'''<br />
</code></pre>
<h3>Operators</h3>
<pre class="prettyprint linenums"><code>from rx import Observable<br />
Observable.of(&quot;Alpha&quot;, &quot;Beta&quot;, &quot;Gamma&quot;, &quot;Delta&quot;, &quot;Epsilon&quot;) \<br />
    .map(lambda s: len(s)) \<br />
    .filter(lambda i: i &gt;= 5) \<br />
    .subscribe(lambda value: print(&quot;Received {0}&quot;.format(value)))<br />
'''<br />
Received 5<br />
Received 5<br />
Received 5<br />
Received 7<br />
'''<br />
</code></pre>
<h3>Events</h3>
<pre class="prettyprint linenums"><code>from rx import Observable<br />
Observable.interval(1000) \<br />
    .map(lambda i: &quot;{0} Mississippi&quot;.format(i)) \<br />
    .subscribe(lambda s: print(s))<br />
input(&quot;Press any key to quit\n&quot;)<br />
'''<br />
Press any key to quit<br />
0 Mississippi<br />
1 Mississippi<br />
2 Mississippi<br />
3 Mississippi<br />
4 Mississippi<br />
...<br />
'''<br />
</code></pre>
<h3>Multicasting</h3>
<pre class="prettyprint linenums"><code>from rx import Observable<br />
from random import randint<br />
three_emissions = Observable.range(1, 3)<br />
three_random_ints = three_emissions.map(lambda i: randint(1, 100000))<br />
three_random_ints.subscribe(lambda i: print(&quot;Subscriber 1 Received: {0}&quot;.format(i)))<br />
three_random_ints.subscribe(lambda i: print(&quot;Subscriber 2 Received: {0}&quot;.format(i)))<br />
'''<br />
Subscriber 1 Received: 76795<br />
Subscriber 1 Received: 19486<br />
Subscriber 1 Received: 96809<br />
Subscriber 2 Received: 79148<br />
Subscriber 2 Received: 33423<br />
Subscriber 2 Received: 3319<br />
'''<br />
</code></pre>
<pre class="prettyprint linenums"><code>from rx import Observable<br />
from random import randint<br />
three_emissions = Observable.range(1, 3)<br />
three_random_ints = three_emissions.map(lambda i: randint(1, 100000)).publish()<br />
three_random_ints.subscribe(lambda i: print(&quot;Subscriber 1 Received: {0}&quot;.format(i)))<br />
three_random_ints.subscribe(lambda i: print(&quot;Subscriber 2 Received: {0}&quot;.format(i)))<br />
three_random_ints.connect()<br />
'''<br />
Subscriber 1 Received: 83159<br />
Subscriber 2 Received: 83159<br />
Subscriber 1 Received: 82025<br />
Subscriber 2 Received: 82025<br />
Subscriber 1 Received: 72397<br />
Subscriber 2 Received: 72397<br />
'''<br />
</code></pre>
<pre class="prettyprint linenums"><code>from rx import Observable<br />
from random import randint<br />
three_emissions = Observable.range(1, 3)<br />
three_random_ints = three_emissions.map(lambda i: randint(1, 100000)).publish().auto_connect(2)<br />
three_random_ints.subscribe(lambda i: print(&quot;Subscriber 1 Received: {0}&quot;.format(i)))<br />
three_random_ints.subscribe(lambda i: print(&quot;Subscriber 2 Received: {0}&quot;.format(i))) # second subscriber triggers firing<br />
'''<br />
Subscriber 1 Received: 72527<br />
Subscriber 2 Received: 72527<br />
Subscriber 1 Received: 53066<br />
Subscriber 2 Received: 53066<br />
Subscriber 1 Received: 32249<br />
Subscriber 2 Received: 32249<br />
'''<br />
</code></pre>
<h3>Combining</h3>
<pre class="prettyprint linenums"><code>from rx import Observable<br />
letters = Observable.of(&quot;Alpha&quot;, &quot;Beta&quot;, &quot;Gamma&quot;, &quot;Delta&quot;, &quot;Epsilon&quot;)<br />
intervals = Observable.interval(1000)<br />
Observable.zip(letters, intervals, lambda s, i: (s, i)) \<br />
    .subscribe(lambda t: print(t))<br />
input(&quot;Press any key to quit\n&quot;)<br />
'''<br />
Press any key to quit<br />
('Alpha', 0)<br />
('Beta', 1)<br />
('Gamma', 2)<br />
('Delta', 3)<br />
('Epsilon', 4)<br />
'''<br />
</code></pre>
<h3>Concurrency</h3>
<pre class="prettyprint linenums"><code>import multiprocessing<br />
import random<br />
import time<br />
from threading import current_thread<br />
from rx import Observable<br />
from rx.concurrency import ThreadPoolScheduler<br />
def intense_calculation(value):<br />
    # sleep for a random short duration between 0.5 to 2.0 seconds to simulate a long-running calculation<br />
    time.sleep(random.randint(5, 20) * .1)<br />
    return value<br />
# calculate number of CPU's, then create a ThreadPoolScheduler with that number of threads<br />
optimal_thread_count = multiprocessing.cpu_count()<br />
pool_scheduler = ThreadPoolScheduler(optimal_thread_count)<br />
# Create Process 1<br />
Observable.of(&quot;Alpha&quot;, &quot;Beta&quot;, &quot;Gamma&quot;, &quot;Delta&quot;, &quot;Epsilon&quot;) \<br />
    .map(lambda s: intense_calculation(s)) \<br />
    .subscribe_on(pool_scheduler) \<br />
    .subscribe(on_next=lambda s: print(&quot;PROCESS 1: {0} {1}&quot;.format(current_thread().name, s)),<br />
               on_error=lambda e: print(e),<br />
               on_completed=lambda: print(&quot;PROCESS 1 done!&quot;))<br />
# Create Process 2<br />
Observable.range(1, 10) \<br />
    .map(lambda s: intense_calculation(s)) \<br />
    .subscribe_on(pool_scheduler) \<br />
    .subscribe(on_next=lambda i: print(&quot;PROCESS 2: {0} {1}&quot;.format(current_thread().name, i)),<br />
               on_error=lambda e: print(e), on_completed=lambda: print(&quot;PROCESS 2 done!&quot;))<br />
# Create Process 3, which is infinite<br />
Observable.interval(1000) \<br />
    .map(lambda i: i * 100) \<br />
    .observe_on(pool_scheduler) \<br />
    .map(lambda s: intense_calculation(s)) \<br />
    .subscribe(on_next=lambda i: print(&quot;PROCESS 3: {0} {1}&quot;.format(current_thread().name, i)),<br />
               on_error=lambda e: print(e))<br />
input(&quot;Press any key to exit\n&quot;)<br />
'''<br />
Press any key to exit<br />
PROCESS 1: ThreadPoolExecutor-1_0 Alpha<br />
PROCESS 1: ThreadPoolExecutor-1_0 Beta<br />
PROCESS 2: ThreadPoolExecutor-1_1 1<br />
PROCESS 3: ThreadPoolExecutor-1_2 0<br />
PROCESS 2: ThreadPoolExecutor-1_1 2<br />
PROCESS 1: ThreadPoolExecutor-1_0 Gamma<br />
PROCESS 3: ThreadPoolExecutor-1_2 100<br />
PROCESS 2: ThreadPoolExecutor-1_1 3<br />
PROCESS 1: ThreadPoolExecutor-1_0 Delta<br />
PROCESS 3: ThreadPoolExecutor-1_4 200<br />
PROCESS 1: ThreadPoolExecutor-1_0 Epsilon<br />
PROCESS 1 done!<br />
PROCESS 2: ThreadPoolExecutor-1_1 4<br />
PROCESS 2: ThreadPoolExecutor-1_1 5<br />
PROCESS 3: ThreadPoolExecutor-1_5 300<br />
PROCESS 2: ThreadPoolExecutor-1_1 6<br />
PROCESS 3: ThreadPoolExecutor-1_2 400<br />
PROCESS 3: ThreadPoolExecutor-1_2 500<br />
PROCESS 2: ThreadPoolExecutor-1_1 7<br />
PROCESS 3: ThreadPoolExecutor-1_2 600<br />
PROCESS 2: ThreadPoolExecutor-1_1 8<br />
PROCESS 3: ThreadPoolExecutor-1_2 700<br />
PROCESS 2: ThreadPoolExecutor-1_1 9<br />
PROCESS 3: ThreadPoolExecutor-1_2 800<br />
PROCESS 2: ThreadPoolExecutor-1_1 10<br />
PROCESS 2 done!<br />
PROCESS 3: ThreadPoolExecutor-1_2 900<br />
PROCESS 3: ThreadPoolExecutor-1_2 1000<br />
PROCESS 3: ThreadPoolExecutor-1_2 1100<br />
PROCESS 3: ThreadPoolExecutor-1_2 1200<br />
PROCESS 3: ThreadPoolExecutor-1_2 1300<br />
PROCESS 3: ThreadPoolExecutor-1_2 1400<br />
PROCESS 3: ThreadPoolExecutor-1_2 1500<br />
PROCESS 3: ThreadPoolExecutor-1_2 1600<br />
PROCESS 3: ThreadPoolExecutor-1_2 1700<br />
PROCESS 3: ThreadPoolExecutor-1_2 1800<br />
...<br />
'''<br />
</code></pre>
<h3>Alignment</h3>
<pre class="prettyprint linenums"><code>from rx import Observable, Observer

xs = Observable.of(1,2,3)<br />
ys = Observable.of(4,5,6)<br />
zs = xs + ys  # Concatenate observables<br />
zs.to_list().subscribe(lambda value: print(value))

xs = Observable.of(1,2,3)<br />
ys = xs * 4<br />
ys.to_list().subscribe(lambda value: print(value))

xs = Observable.of(1,2,3)<br />
ys = xs[1:-1]<br />
ys.to_list().subscribe(lambda value: print(value))

xs = Observable.of(1,2,3,4,5,6)<br />
ys = xs.to_blocking()<br />
zs = (x*x for x in ys if x &gt; 3)<br />
for x in zs:<br />
    print(x)<br />
'''<br />
[1, 2, 3, 4, 5, 6]<br />
[1, 2, 3, 1, 2, 3, 1, 2, 3, 1, 2, 3]<br />
[2]<br />
16<br />
25<br />
36<br />
'''<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rql5eok8.html">&lbrack;Bug&rsqb;枚举数组，并找到某些元素删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/r9365zr9.html">最清晰的Android多屏幕适配方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m576pq.html">Java复数的四则运算</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok33m19.html">设置 MyEclipse 默认打开文件方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mjljxq.html">multiple build commands for output file</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdy3gy8.html">javascript&mdash;&mdash;集合类</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdgpkl8.html">lab3</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdn0679.html">POJ 3301 Texas Trip</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjojlr8.html">Python 学习笔记7</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp1ndvq.html">Java网络编程基础&lpar;Netty预备知识&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mw4lj8.html">安装&lowbar;oracle11G&lowbar;客户端&lowbar;服务端&lowbar;链接&lowbar;oracle</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1jwzw9.html">spring 定时任务执行2次</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r4g448.html">Codeforces Round &num;113 &lpar;Div&period; 2&rpar; B&period; Polygons Andrew求凸包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e430ex9.html">apply、call、bind的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/960lygj9.html">ionic2一个需求模块的文件该是这样子的</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5wvkmq.html">span 文本内容超过宽度自动换行</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4n6zj9.html">100-days&colon;nine</a>
		</li>
						<li><a href="https://www.batexi.com/a/93we1vrq.html">TZOJ 4325 RMQ with Shifts&lpar;线段树查询最小，暴力更新&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql15gv09.html">JDBC进行简单的增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1vnn40q.html">【jQuery】页面顶部显示的进度条效果</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q25p60vq.html">jdbc连接池&amp;amp&semi;改进dbUtil成C3P0Util</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyyzorjq.html">MybatisUtil的使用，便于产生SqlSession</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g2nnmq.html">Python&colon; 如何写一个异常</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv3xry8.html">C语言中 有符号数、无符号数、整数溢出 （转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r6l5m9.html">C&sol;C&num;双色球</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjxe339.html">一个不错的PHP二维数组排序函数简单易用存用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j15w149.html">linux的可中断sleep&lowbar;on函数分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/90r6zpn9.html">canal 配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvp7og8.html">图片 base64转byte&lbrack;&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o1m7ypq.html">java&period;lang&period;IllegalMonitorStateException异常</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
